package componentesmm_v1.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class ConnectorReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public ConnectorReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof componentesmm_v1.Connector) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof componentesmm_v1.Port && newEnd instanceof componentesmm_v1.Port)) {
			return false;
		}
		componentesmm_v1.Port target = getLink().getTarget();
		if (!(getLink().eContainer() instanceof componentesmm_v1.ComplexComponent)) {
			return false;
		}
		componentesmm_v1.ComplexComponent container = (componentesmm_v1.ComplexComponent) getLink()
				.eContainer();
		return componentesmm_v1.diagram.edit.policies.ComponentesMM_V2BaseItemSemanticEditPolicy
				.getLinkConstraints().canExistConnector_4003(container,
						getLink(), getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof componentesmm_v1.Port && newEnd instanceof componentesmm_v1.Port)) {
			return false;
		}
		componentesmm_v1.Port source = getLink().getSource();
		if (!(getLink().eContainer() instanceof componentesmm_v1.ComplexComponent)) {
			return false;
		}
		componentesmm_v1.ComplexComponent container = (componentesmm_v1.ComplexComponent) getLink()
				.eContainer();
		return componentesmm_v1.diagram.edit.policies.ComponentesMM_V2BaseItemSemanticEditPolicy
				.getLinkConstraints().canExistConnector_4003(container,
						getLink(), source, getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setSource(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setTarget(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected componentesmm_v1.Connector getLink() {
		return (componentesmm_v1.Connector) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected componentesmm_v1.Port getOldSource() {
		return (componentesmm_v1.Port) oldEnd;
	}

	/**
	 * @generated
	 */
	protected componentesmm_v1.Port getNewSource() {
		return (componentesmm_v1.Port) newEnd;
	}

	/**
	 * @generated
	 */
	protected componentesmm_v1.Port getOldTarget() {
		return (componentesmm_v1.Port) oldEnd;
	}

	/**
	 * @generated
	 */
	protected componentesmm_v1.Port getNewTarget() {
		return (componentesmm_v1.Port) newEnd;
	}
}
