/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package componentesmm_v1.util;

import componentesmm_v1.*;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see componentesmm_v1.Componentesmm_v1Package
 * @generated
 */
public class Componentesmm_v1Validator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final Componentesmm_v1Validator INSTANCE = new Componentesmm_v1Validator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "componentesmm_v1";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Componentesmm_v1Validator() {
		super();
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return Componentesmm_v1Package.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case Componentesmm_v1Package.COMPONENT:
				return validateComponent((Component)value, diagnostics, context);
			case Componentesmm_v1Package.SIMPLE_COMPONENT:
				return validateSimpleComponent((SimpleComponent)value, diagnostics, context);
			case Componentesmm_v1Package.COMPLEX_COMPONENT:
				return validateComplexComponent((ComplexComponent)value, diagnostics, context);
			case Componentesmm_v1Package.INTERFACE:
				return validateInterface((Interface)value, diagnostics, context);
			case Componentesmm_v1Package.CONNECTOR:
				return validateConnector((Connector)value, diagnostics, context);
			case Componentesmm_v1Package.REQUIRED_INTERFACE:
				return validateRequiredInterface((RequiredInterface)value, diagnostics, context);
			case Componentesmm_v1Package.PROVIDED_INTERFACE:
				return validateProvidedInterface((ProvidedInterface)value, diagnostics, context);
			case Componentesmm_v1Package.NAMED_ELEMENT:
				return validateNamedElement((NamedElement)value, diagnostics, context);
			case Componentesmm_v1Package.PORT:
				return validatePort((Port)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComponent(Component component, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(component, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(component, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(component, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(component, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(component, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(component, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(component, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(component, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(component, diagnostics, context);
		if (result || diagnostics != null) result &= validateComponent_DistintoNombre(component, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the DistintoNombre constraint of '<em>Component</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String COMPONENT__DISTINTO_NOMBRE__EEXPRESSION = "Component.allInstances()->forAll(c1 : Component, c2 : Component | c1 <> c2 implies c1.name <> c2.name)";

	/**
	 * Validates the DistintoNombre constraint of '<em>Component</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComponent_DistintoNombre(Component component, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(Componentesmm_v1Package.Literals.COMPONENT,
				 component,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "DistintoNombre",
				 COMPONENT__DISTINTO_NOMBRE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSimpleComponent(SimpleComponent simpleComponent, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(simpleComponent, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(simpleComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validateComponent_DistintoNombre(simpleComponent, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComplexComponent(ComplexComponent complexComponent, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(complexComponent, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(complexComponent, diagnostics, context);
		if (result || diagnostics != null) result &= validateComponent_DistintoNombre(complexComponent, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInterface(Interface interface_, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(interface_, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateConnector(Connector connector, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(connector, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validateConnector_PuertosMismoNivelInterfazDistinta(connector, diagnostics, context);
		if (result || diagnostics != null) result &= validateConnector_PuertosDistintoNivelComponentesIntToExt(connector, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the PuertosDistintoNivelComponentesIntToExt constraint of '<em>Connector</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String CONNECTOR__PUERTOS_DISTINTO_NIVEL_COMPONENTES_INT_TO_EXT__EEXPRESSION = "self.source.container = self.target.container.container or self.source.container.container = self.target.container and self.source.interfaces->notEmpty() implies self.source.interfaces->forAll(i : Interface | self.target.interfaces->exists(j : Interface | i.name = j.name and (i.oclIsTypeOf(RequiredInterface) and j.oclIsTypeOf(RequiredInterface) or j.oclIsTypeOf(ProvidedInterface) and i.oclIsTypeOf(ProvidedInterface))))";

	/**
	 * Validates the PuertosDistintoNivelComponentesIntToExt constraint of '<em>Connector</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateConnector_PuertosDistintoNivelComponentesIntToExt(Connector connector, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(Componentesmm_v1Package.Literals.CONNECTOR,
				 connector,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "PuertosDistintoNivelComponentesIntToExt",
				 CONNECTOR__PUERTOS_DISTINTO_NIVEL_COMPONENTES_INT_TO_EXT__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * The cached validation expression for the PuertosMismoNivelInterfazDistinta constraint of '<em>Connector</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String CONNECTOR__PUERTOS_MISMO_NIVEL_INTERFAZ_DISTINTA__EEXPRESSION = "self.source.container.container = self.target.container.container and self.source.interfaces->notEmpty() implies self.source.interfaces->forAll(i : Interface | self.target.interfaces->exists(j : Interface | i.name = j.name and (i.oclIsTypeOf(RequiredInterface) and j.oclIsTypeOf(ProvidedInterface) or j.oclIsTypeOf(RequiredInterface) and i.oclIsTypeOf(ProvidedInterface))))";

	/**
	 * Validates the PuertosMismoNivelInterfazDistinta constraint of '<em>Connector</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateConnector_PuertosMismoNivelInterfazDistinta(Connector connector, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(Componentesmm_v1Package.Literals.CONNECTOR,
				 connector,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "PuertosMismoNivelInterfazDistinta",
				 CONNECTOR__PUERTOS_MISMO_NIVEL_INTERFAZ_DISTINTA__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRequiredInterface(RequiredInterface requiredInterface, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(requiredInterface, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateProvidedInterface(ProvidedInterface providedInterface, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(providedInterface, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNamedElement(NamedElement namedElement, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(namedElement, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePort(Port port, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(port, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(port, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(port, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(port, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(port, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(port, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(port, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(port, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(port, diagnostics, context);
		if (result || diagnostics != null) result &= validatePort_InterfazDistintoNombre(port, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the InterfazDistintoNombre constraint of '<em>Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String PORT__INTERFAZ_DISTINTO_NOMBRE__EEXPRESSION = "self.interfaces->forAll(i : Interface | self.interfaces->exists(j : Interface | i.name <> j.name)) or self.interfaces->size() = 1";

	/**
	 * Validates the InterfazDistintoNombre constraint of '<em>Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePort_InterfazDistintoNombre(Port port, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(Componentesmm_v1Package.Literals.PORT,
				 port,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "InterfazDistintoNombre",
				 PORT__INTERFAZ_DISTINTO_NOMBRE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //Componentesmm_v1Validator
